# m3e/icon_button

IconButton is an icon button users interact with to perform a supplementary action.

This file was generated: By: m3e/generator version 0.1.0 At: 2026-05-05T14:38:23+10:00

         DO NOT EDIT

# Types

## Config

</>

Config is a public record for configuring this component.

    pub type Config {
      Config(
        disabled: Disabled,
        disabled_interactive: DisabledInteractive,
        download: option.Option(String),
        href: String,
        name: String,
        rel: String,
        selected: Selected,
        shape: icon_button_shape.IconButtonShape,
        size: icon_button_size.IconButtonSize,
        target: option.Option(link_target.LinkTarget),
        toggle: Toggle,
        type_: form_submitter_type.FormSubmitterType,
        value: String,
        variant: icon_button_variant.IconButtonVariant,
        width: icon_button_width.IconButtonWidth,
      )
    }

### Constructors

-     Config(
        disabled: Disabled,
        disabled_interactive: DisabledInteractive,
        download: option.Option(String),
        href: String,
        name: String,
        rel: String,
        selected: Selected,
        shape: icon_button_shape.IconButtonShape,
        size: icon_button_size.IconButtonSize,
        target: option.Option(link_target.LinkTarget),
        toggle: Toggle,
        type_: form_submitter_type.FormSubmitterType,
        value: String,
        variant: icon_button_variant.IconButtonVariant,
        width: icon_button_width.IconButtonWidth,
      )

## Disabled

</>

Disabled is whether the element is disabled.

    pub type Disabled {
      IsDisabled
      IsNotDisabled
    }

### Constructors

-     IsDisabled

-     IsNotDisabled

## DisabledInteractive

</>

DisabledInteractive is whether the element is disabled and interactive.

    pub type DisabledInteractive {
      IsDisabledInteractive
      IsNotDisabledInteractive
    }

### Constructors

-     IsDisabledInteractive

-     IsNotDisabledInteractive

## IconButton

opaque </>

IconButton is a View Model for this component

## Fields:

- disabled: Whether the element is disabled.
- disabled_interactive: Whether the element is disabled and interactive.
- download: A value indicating whether the `target` of the link button will be downloaded, optionally specifying the new name of the file.
- href: The URL to which the link button points.
- name: The name of the element, submitted as a pair with the element’s `value` as part of form data, when the element is used to submit a form.
- rel: The relationship between the `target` of the link button and the document.
- selected: Whether the toggle button is selected.
- shape: The shape of the button.
- size: The size of the button.
- target: The target of the link button.
- toggle: Whether the button will toggle between selected and unselected states.
- type_: The type of the element.
- value: The value associated with the element’s name when it’s submitted with form data.
- variant: The appearance variant of the button.
- width: The width of the button.

    pub opaque type IconButton

## Selected

</>

Selected is whether the toggle button is selected.

    pub type Selected {
      IsSelected
      IsNotSelected
    }

### Constructors

-     IsSelected

-     IsNotSelected

## Slot

</>

Slots are used in child elements to insert content into this component

    pub type Slot {
      Selected
    }

### Constructors

-     Selected

## Toggle

</>

Toggle is whether the button will toggle between selected and unselected states.

    pub type Toggle {
      IsToggle
      IsNotToggle
    }

### Constructors

-     IsToggle

-     IsNotToggle

# Values

## default_config

</>

    pub fn default_config() -> Config

default_config is the default configuration for this component.

## default_disabled

</>

    pub const default_disabled: Disabled

## default_disabled_interactive

</>

    pub const default_disabled_interactive: DisabledInteractive

## default_download

</>

    pub const default_download: option.Option(String)

## default_href

</>

    pub const default_href: String

## default_name

</>

    pub const default_name: String

## default_rel

</>

    pub const default_rel: String

## default_selected

</>

    pub const default_selected: Selected

## default_shape

</>

    pub const default_shape: icon_button_shape.IconButtonShape

## default_size

</>

    pub const default_size: icon_button_size.IconButtonSize

## default_target

</>

    pub const default_target: option.Option(link_target.LinkTarget)

## default_toggle

</>

    pub const default_toggle: Toggle

## default_type_

</>

    pub const default_type_: form_submitter_type.FormSubmitterType

## default_value

</>

    pub const default_value: String

## default_variant

</>

    pub const default_variant: icon_button_variant.IconButtonVariant

## default_width

</>

    pub const default_width: icon_button_width.IconButtonWidth

## disabled

</>

    pub fn disabled(
      record: IconButton,
      disabled: Disabled,
    ) -> IconButton

disabled sets the value of disabled for this IconButton.

## disabled_interactive

</>

    pub fn disabled_interactive(
      record: IconButton,
      disabled_interactive: DisabledInteractive,
    ) -> IconButton

disabled_interactive sets the value of disabled_interactive for this IconButton.

## download

</>

    pub fn download(
      record: IconButton,
      download: option.Option(String),
    ) -> IconButton

download sets the value of download for this IconButton.

## from_config

</>

    pub fn from_config(config: Config) -> IconButton

from_config creates a new IconButton from the given configuration.

## href

</>

    pub fn href(record: IconButton, href: String) -> IconButton

href sets the value of href for this IconButton.

## name

</>

    pub fn name(record: IconButton, name: String) -> IconButton

name sets the value of name for this IconButton.

## new

</>

    pub fn new() -> IconButton

new creates a new IconButton with the default configuration.

## rel

</>

    pub fn rel(record: IconButton, rel: String) -> IconButton

rel sets the value of rel for this IconButton.

## render

</>

    pub fn render(
      model: IconButton,
      attributes: List(attribute.Attribute(msg)),
      children: List(element.Element(msg)),
    ) -> element.Element(msg)

render creates a Lustre Element for a IconButton

## render_config

</>

    pub fn render_config(
      c: Config,
      attributes: List(attribute.Attribute(msg)),
      children: List(element.Element(msg)),
    ) -> element.Element(msg)

render_config creates a Lustre Element from a IconButton Config

## selected

</>

    pub fn selected(
      record: IconButton,
      selected: Selected,
    ) -> IconButton

selected sets the value of selected for this IconButton.

## shape

</>

    pub fn shape(
      record: IconButton,
      shape: icon_button_shape.IconButtonShape,
    ) -> IconButton

shape sets the value of shape for this IconButton.

## size

</>

    pub fn size(
      record: IconButton,
      size: icon_button_size.IconButtonSize,
    ) -> IconButton

size sets the value of size for this IconButton.

## slot

</>

    pub fn slot(s: Slot) -> attribute.Attribute(msg)

slot returns a Lustre Attribute(msg) for the given slot name

## target

</>

    pub fn target(
      record: IconButton,
      target: option.Option(link_target.LinkTarget),
    ) -> IconButton

target sets the value of target for this IconButton.

## toggle

</>

    pub fn toggle(record: IconButton, toggle: Toggle) -> IconButton

toggle sets the value of toggle for this IconButton.

## type_

</>

    pub fn type_(
      record: IconButton,
      type_: form_submitter_type.FormSubmitterType,
    ) -> IconButton

type_ sets the value of type_ for this IconButton.

## value

</>

    pub fn value(record: IconButton, value: String) -> IconButton

value sets the value of value for this IconButton.

## variant

</>

    pub fn variant(
      record: IconButton,
      variant: icon_button_variant.IconButtonVariant,
    ) -> IconButton

variant sets the value of variant for this IconButton.

## width

</>

    pub fn width(
      record: IconButton,
      width: icon_button_width.IconButtonWidth,
    ) -> IconButton

width sets the value of width for this IconButton.

✨